<?php
// $Id: person.inc,v 1.7 2006/04/06 03:07:47 unconed Exp $

/**
 * Implementation of hook_access().
 */
function scouting_person_access($op, $node) {
  return _scouting_access($op, $node);
}

/**
 * Implementation of hook_form().
 */
function scouting_person_form(&$node, &$param) {
  scouting_custom_theme();

  $form['c'] = array('#weight' => -1);
  $form['c']['markup1'] = array('#value' => '<div class="inline-fieldsets">');

  $form['c']['name'] = array('#type' => 'fieldset', '#title' => t('Name'));
  $form['c']['name']['forename'] = array('#type' => 'textfield', '#title' => t('Forename'), '#size' => 32, '#maxlength' => 64, '#required' => TRUE, '#default_value' => $node->forename);
  $form['c']['name']['surname'] = array('#type' => 'textfield', '#title' => t('Surname'), '#size' => 32, '#maxlength' => 64, '#required' => TRUE, '#default_value' => $node->surname);
  $form['c']['name']['prefname'] = array('#type' => 'textfield', '#title' => t('Preferred Name'), '#size' => 32, '#maxlength' => 64, '#required' => TRUE, '#default_value' => $node->prefname);

  $form['c']['contact'] = array('#type' => 'fieldset', '#title' => t('Contact Details'));
  $form['c']['contact']['email'] = array('#type' => 'textfield', '#title' => t('Email'), '#size' => 32, '#maxlength' => 255, '#default_value' => $node->email);
  $form['c']['contact']['phone_number'] = array('#type' => 'textfield', '#title' => t('Phone Number'), '#size' => 12, '#maxlength' => 32, '#default_value' => $node->phone_number);
  $form['c']['contact']['mobile_number'] = array('#type' => 'textfield', '#title' => t('Mobile Number'), '#size' => 12, '#maxlength' => 32, '#default_value' => $node->mobile_number);

  $form['c']['markup2'] = array('#value' => '</div><div class="inline-fieldsets">');

  $form['c']['address'] = array('#type' => 'fieldset', '#title' => t('Address'));
  $form['c']['address']['address1'] = array('#type' => 'textfield', '#title' => t('Address 1'), '#size' => 32, '#maxlength' => 64, '#default_value' => $node->address1);
  $form['c']['address']['address2'] = array('#type' => 'textfield', '#title' => t('Address 2'), '#size' => 32, '#maxlength' => 64, '#default_value' => $node->address2);
  $form['c']['address']['town'] = array('#type' => 'textfield', '#title' => t('Town'), '#size' => 32, '#maxlength' => 64, '#default_value' => $node->town);
  $form['c']['address']['county'] = array('#type' => 'textfield', '#title' => t('County'), '#size' => 32, '#maxlength' => 64, '#default_value' => $node->county);
  $form['c']['address']['postcode'] = array('#type' => 'textfield', '#title' => t('Postcode'), '#size' => 32, '#maxlength' => 64, '#default_value' => $node->postcode);

  $form['c']['misc'] = array('#type' => 'fieldset', '#title' => t('Misc'));

  // @@ TODO: fit taxonomy into here rather than default location

  $form['c']['misc']['dob'] = array('#type' => 'textfield', '#title' => t('DOB'), '#size' => 20, '#maxlength' => 32, '#default_value' => scouting_format_date($node->dob));
  $form['c']['misc']['crb'] = array('#type' => 'checkbox', '#title' => t('CRB'), '#default_value' => $node->crb);
  $form['c']['misc']['driver'] = array('#type' => 'checkbox', '#title' => t('Driver'), '#default_value' => $node->driver);
  $form['c']['misc']['minibus'] = array('#type' => 'checkbox', '#title' => t('Minibus'), '#default_value' => $node->minibus);
  $form['c']['misc']['photo_permission'] = array('#type' => 'checkbox', '#title' => t('Photo permission'), '#default_value' => $node->photo_permission);

  $form['c']['markup3'] = array('#value' => '</div>');

  $form['body'] = array('#type' => 'textarea', '#title' => t('Medical Notes'), '#default_value' => $node->body, '#weight' => 0, '#rows' => 5);

  return $form;
}

/**
 * Implementation of hook_validate().
 */
function scouting_person_validate(&$node) {
  $node->title = scouting_person_display_name($node);
  $node->dob = scouting_strtotime($node->dob);
}

/**
 * Implementation of hook_load().
 */
function scouting_person_load($node) {
  return db_fetch_object(db_query('SELECT * FROM {scouting_person} WHERE nid = %d', $node->nid));
}

/**
 * Implementation of hook_insert().
 */
function scouting_person_insert($node) {
  db_query("INSERT INTO {scouting_person} (nid, forename, surname, prefname, dob, email, phone_number,mobile_number, address1, address2, town, county, postcode, crb, driver, minibus, photo_permission) VALUES (%d, '%s', '%s', %d, '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', %d, %d, %d, %d)", $node->nid, $node->forename, $node->surname, $node->prefname, $node->dob, $node->email, $node->phone_number, $node->mobile_number, $node->address1, $node->address2, $node->town, $node->county, $node->postcode, $node->crb, $node->driver, $node->minibus, $node->photo_permission);
}

/**
 * Implementation of hook_update().
 */
function scouting_person_update($node) {
  db_query("UPDATE {scouting_person} SET forename='%s',surname='%s', prefname='%s',dob=%d,email='%s',phone_number='%s',mobile_number='%s', address1='%s', address2='%s', town='%s', county='%s', postcode='%s', crb=%d,driver=%b,minibus=%d,photo_permission=%d WHERE nid = %d", $node->forename, $node->surname, $node->prefname, $node->dob, $node->email, $node->phone_number, $node->mobile_number, $node->address1, $node->address2, $node->town, $node->county, $node->postcode, $node->crb, $node->driver, $node->minibus, $node->photo_permission, $node->nid);
}

/**
 * Implementation of hook_delete().
 */
function scouting_person_delete($node) {
  db_query('DELETE FROM {scouting_person} WHERE nid = %d', $node->nid);
}

/**
 * Return the concatenated name of a person
 */
function scouting_person_display_name($node) {
  if ($node->surname && $node->forename) {
    return $node->surname.', '. $node->forename;
  }
  return '';
}

/**
 * Implementation of hook_view().
 */
function scouting_person_view(&$node, $teaser = false, $page = false) {
  scouting_custom_theme();

  $node->notes = $node->body;

  $header = array(t('Section'), t('Member type'), t('Date joined'), t('Date invested'), t('Date left'));

  $rs = db_query('SELECT
  n.title,
  n.nid,
  mt.name AS "member_type",
  m.nid AS "member_id",
  m.date_joined,
  m.date_invested,
  m.date_left
FROM
  {node} n,
  {scouting_section} s,
  {scouting_membership} m,
  {scouting_membership_type} mt
WHERE
  n.nid = s.nid
  AND m.section_id = s.nid
  AND m.member_type_id = mt.id
  AND m.person_id = %d
ORDER BY
m.date_joined', $node->nid);

  $rows = array();
  while ($section = db_fetch_object($rs)) {
    $rows[] = array(
      l($section->title, 'node/'.$section->nid),
      l($section->member_type, 'node/'.$section->member_id),
      scouting_format_date($section->date_joined),
      scouting_format_date($section->date_invested),
      scouting_format_date($section->date_left)
    );
  }
  if (count($rows) == 0) {
    $rows[] = array(array('data' => t('None'), 'colspan' => count($header)));
  }

  $address = str_replace('<br /><br />', '<br />', implode('<br />', array($node->address1, $node->address2, $node->town, $node->county, $node->postcode)));

  $info = array(
    t('E-mail') => $node->email ? '<a href="mailto:'.$node->email.'">'.$node->email.'</a>' : '',
    t('Phone number') => $node->phone_number,
    t('Mobile number') => $node->mobile_number,
    t('DOB') => scouting_format_date($node->dob),
    t('Age') => $node->dob ? format_interval(time() - $node->dob) : '',
    t('Address') => $address != '<br /><br />' ? $address : '',
    t('Medical Notes') => check_markup($node->notes, $node->format),
  );

  $sections = theme('table', $header, $rows);
  $sections .= '<p>'. l(t('Add to a Section'), 'node/add/scouting_membership', null, 'personid='.$node->nid) .'</p>';

  $output = theme('fieldset', array('#title' => t('Details'), '#children' => theme('scouting_definition_list', $info)));
  $output .= theme('fieldset', array('#title' => t('Sections'), '#children' => $sections));

  $node->body = $output;
}

/**
 * Display a list of all people in the database
 */
function scouting_people_list_page() {
  scouting_custom_theme();

  $header = array(
    array('data' => t('Surname'), 'field' => 'p.surname'),
    array('data' => t('Forename'), 'field' => 'p.forename'),
    array('data' => t('Email'), 'field' => 'p.email'),
    array('data' => t('DOB'), 'field' => 'p.dob'),
    array('data' => t('Age'), 'field' => 'age'),
    array('data' => t('Created'), 'field' => 'n.created'),
    array('data' => t('Changed'), 'field' => 'n.changed')
  );

  $sql = 'SELECT n.nid, p.forename, p.surname, p.email, p.dob, '.time().'-p.dob AS "age", n.created, n.changed FROM {node} n, {scouting_person} p WHERE n.type="scouting_person" AND n.nid=p.nid'.tablesort_sql($header);

  $result = pager_query($sql, 25);

  while ($node = db_fetch_object($result)) {
    $rows[] = array(
      l($node->surname, 'node/'.$node->nid),
      $node->forename,
      $node->email ? '<a href="mailto:'.$node->email.'">'.scouting_column_width($node->email, 16).'</a>' : '',
      scouting_format_date($node->dob),
      ($node->dob) ? format_interval($node->age, 1) : '',
      scouting_format_date($node->created),
      scouting_format_date($node->changed)
    );
  }

  if ($pager = theme('pager', NULL, 25, 0, tablesort_pager())) {
    $rows[] = array(array('data' => $pager, 'colspan' => count($header)));
  }

  $output = theme('table', $header, $rows);

  return $output;
}

function scouting_people_autocomplete($string = '', $limit = 10) {
  $matches = array();
  $string = strtolower($string);
  $limit = 10;
  $rs = db_query('SELECT forename, surname FROM {scouting_person} WHERE forename LIKE "%%%s%%" OR surname LIKE "%%%s%%"', $string, $string, $limit);
  while ($node = db_fetch_object($rs)) {
    $name = scouting_person_display_name($node);
    $matches[$name] = $name;
  }
  echo drupal_to_js($matches);
  exit();
}

function scouting_person_name_from_id($id) {
  static $cache;
  if (!$cache[$id]) {
    $node = db_fetch_object(db_query('SELECT forename, surname, prefname FROM {scouting_person} WHERE nid=%d', $id));
    $cache[$id] = scouting_person_display_name($node);
  }
  return $cache[$id];
}

function scouting_person_id_from_name($name) {
  static $cache;
  if (!$cache[$name]) {
    list($surname, $forename) = explode(', ', $name);
    $cache[$name] = db_result(db_query('SELECT nid FROM {scouting_person} WHERE surname="%s" AND forename="%s"', $surname, $forename));
  }
  return $cache[$name];
}

