-- $Id: scouting.mysql.sql,v 1.3 2006/01/09 13:16:48 thox Exp $

CREATE TABLE scouting_event_participant (
  member_id int(10) unsigned NOT NULL default '0',
  event_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (member_id,event_id)
);

CREATE TABLE scouting_event (
  nid int(10) unsigned NOT NULL default '0',
  nights_away int(3) unsigned NOT NULL default '0',
  event_type_id smallint(3) unsigned NOT NULL default '0',
  event_date int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (nid)
);

CREATE TABLE scouting_person (
  nid int(10) unsigned NOT NULL default '0',
  forename varchar(64) NOT NULL default '',
  surname varchar(64) NOT NULL default '',
  prefname varchar(64) NOT NULL default '',
  dob int(11) unsigned NOT NULL default '0',
  email varchar(255) NOT NULL default '',
  phone_number varchar(32) NOT NULL default '',
  mobile_number varchar(32) NOT NULL default '',
  address1 varchar(128) NOT NULL default '',
  address2 varchar(128) NOT NULL default '',
  town varchar(128) NOT NULL default '',
  county varchar(128) NOT NULL default '',
  postcode varchar(10) NOT NULL default '',
  crb tinyint(1) unsigned NOT NULL default '0',
  driver tinyint(1) unsigned NOT NULL default '0',
  minibus tinyint(1) unsigned NOT NULL default '0',
  photo_permission tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (nid)
);

CREATE TABLE scouting_membership (
  nid int(10) unsigned NOT NULL default '0',
  person_id int(10) unsigned NOT NULL default '0',
  member_type_id smallint(3) unsigned NOT NULL default '0',
  section_id int(10) unsigned NOT NULL default '0',
  date_joined int(11) unsigned NOT NULL default '0',
  date_invested int(11) unsigned NOT NULL default '0',
  date_left int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (nid)
);

CREATE TABLE scouting_membership_type (
  id smallint(3) unsigned NOT NULL auto_increment,
  name varchar(50) NOT NULL default '',
  level enum('Area/County','District','Group') NOT NULL default 'Group',
  PRIMARY KEY  (id)
);

INSERT INTO scouting_membership_type (id, name, level) VALUES
(1, 'Waiting List', 'Group'),
(2, 'Active Member', 'Group'),
(3, 'Inactive Member', 'Group'),
(4, 'Assistant Beaver Leader', 'Group'),
(7, 'Assistant Cub Leader', 'Group'),
(8, 'Assistant Scout Leader', 'Group'),
(9, 'Assistant Group Scout Leader', 'Group'),
(10, 'Beaver Leader', 'Group'),
(11, 'Cub Leader', 'Group'),
(14, 'Group Scout Leader', 'Group'),
(15, 'Scout Leader', 'Group'),
(33, 'Sectional Assistants', 'Group'),
(34, 'Chairman', 'Group'),
(35, 'Treasurer', 'Group'),
(36, 'Secretary', 'Group'),
(37, 'Other', 'Group'),
(39, 'Commissioner', 'District'),
(40, 'Assistant Commissioner', 'District'),
(41, 'Explorer Scout Commissioner', 'District'),
(42, 'Explorer Scout Leader', 'District'),
(43, 'Explorer Scouts', 'District'),
(44, 'Explorer District Leader', 'District'),
(45, 'Adviser', 'District'),
(46, 'Skills Instructor', 'District'),
(47, 'Secretary', 'District'),
(48, 'Chairman', 'District'),
(49, 'Treasurer', 'District'),
(50, 'Scout Fellowship Chairman', 'District'),
(51, 'Other', 'District'),
(52, 'Commissioner', 'Area/County'),
(53, 'Deputy Commissioner', 'Area/County'),
(54, 'Assistant Commissioner', 'Area/County'),
(55, 'Scout Network Commissioner', 'Area/County'),
(56, 'Scout Network Leader', 'Area/County'),
(57, 'Training Manager', 'Area/County'),
(58, 'Local Training Manager', 'Area/County'),
(59, 'Treasurer', 'Area/County'),
(60, 'Secretary', 'Area/County'),
(61, 'Chairman', 'Area/County'),
(62, 'Administrator', 'Area/County'),
(63, 'Adviser', 'Area/County'),
(64, 'Skills Instructor', 'Area/County'),
(65, 'Child Protection Co-ordinator', 'Area/County'),
(66, 'Other', 'Area/County'),
(67, 'Helper', 'Group');

CREATE TABLE scouting_event_type (
  id smallint(3) unsigned NOT NULL auto_increment,
  eventcategoryid tinyint(4) unsigned NOT NULL default '0',
  name varchar(50) NOT NULL default '',
  PRIMARY KEY  (id)
);

INSERT INTO scouting_event_type (id, eventcategoryid, name) VALUES
(120, 1, 'Animal Friend'),
(121, 1, 'Creative'),
(122, 1, 'Experiment'),
(123, 1, 'Explore'),
(124, 1, 'Faith'),
(125, 2, 'Adventure'),
(126, 2, 'Air Activities'),
(127, 2, 'Animal Carer'),
(128, 2, 'Art'),
(129, 2, 'Athletics'),
(130, 2, 'Book reader'),
(131, 2, 'Camper'),
(132, 2, 'Chef'),
(133, 2, 'Collector'),
(134, 2, 'Communicator'),
(135, 2, 'Cyclist'),
(136, 2, 'DIY'),
(137, 2, 'Emergency Aid'),
(138, 2, 'Entertainer'),
(139, 2, 'Equestrian'),
(140, 2, 'My Faith'),
(141, 2, 'World Faith'),
(142, 2, 'Global Conservation'),
(143, 2, 'Hobbies'),
(144, 2, 'Home Help'),
(145, 2, 'Home Safety'),
(146, 2, 'Local Knowledge'),
(147, 2, 'Martial Arts'),
(148, 2, 'Naturalist'),
(149, 2, 'Navigator'),
(150, 2, 'Personal Safety'),
(151, 2, 'Physical Recreation'),
(152, 2, 'Road Safety'),
(153, 2, 'Scientist'),
(154, 2, 'Skater'),
(155, 2, 'Sports Enthusiast'),
(156, 2, 'Water Activities'),
(157, 3, 'Administrator'),
(158, 3, 'Aeronautics'),
(159, 3, 'Air Researcher'),
(160, 3, 'Air Spotter'),
(161, 3, 'Athletics'),
(162, 3, 'Basic Aviation Skills'),
(163, 3, 'Aviation Skills'),
(164, 3, 'Advanced Aviation Skills'),
(165, 3, 'Angler'),
(166, 3, 'Artist'),
(167, 3, 'Arts Enthusiast'),
(168, 3, 'Astronomer'),
(169, 3, 'Camp Cook'),
(170, 3, 'Camper'),
(171, 3, 'Campsite'),
(172, 3, 'Canoeist'),
(173, 3, 'Caver'),
(174, 3, 'Chef'),
(175, 3, 'Circus Skills'),
(176, 3, 'Climber'),
(177, 3, 'Community'),
(178, 3, 'Craft'),
(179, 3, 'Cyclist'),
(180, 3, 'DIY'),
(181, 3, 'Dragon Boating'),
(182, 3, 'Electronics'),
(183, 3, 'Emergancy Aid'),
(184, 3, 'Entertainer'),
(185, 3, 'Equestrian'),
(186, 3, 'My Faith'),
(187, 3, 'World Faith'),
(188, 3, 'Fire Safety'),
(189, 3, 'Forester'),
(190, 3, 'Global Conservation'),
(191, 3, 'Guide'),
(192, 3, 'Dinghy Sailor'),
(193, 3, 'Heritage'),
(194, 3, 'Hiker'),
(195, 3, 'Hill Walker'),
(196, 3, 'Hobbies'),
(197, 3, 'Interpreter'),
(198, 3, 'Librarian'),
(199, 3, 'Lifesaver'),
(200, 3, 'Martial Arts'),
(201, 3, 'Master at Arms'),
(202, 3, 'Mechanic'),
(203, 3, 'Meteorologists'),
(204, 3, 'Model Maker'),
(205, 3, 'Naturalist'),
(206, 3, 'Navigator'),
(207, 3, 'Orienteer'),
(208, 3, 'Photographer'),
(209, 3, 'Physical Recreation'),
(210, 3, 'Pioneer'),
(211, 3, 'Power Coxswain'),
(212, 3, 'Public Relations'),
(213, 3, 'Pulling'),
(214, 3, 'Quartermaster'),
(215, 3, 'Racing Helm'),
(216, 3, 'Radio Communicator'),
(217, 3, 'Basic Nautical Skills'),
(218, 3, 'Skater'),
(219, 3, 'Small Holder'),
(220, 3, 'Snowsports'),
(221, 3, 'Sports Enthusist'),
(222, 3, 'Survival Skills'),
(223, 3, 'Water Sports'),
(224, 3, 'Writer'),
(225, 4, 'Air Activities'),
(226, 4, 'Aviation Skills'),
(227, 4, 'Advanced Aviation Skills'),
(228, 4, 'Community'),
(229, 4, 'Creative'),
(230, 4, 'Emergancy Aid'),
(231, 4, 'Lifesaver'),
(232, 4, 'Mountain Activities'),
(233, 4, 'Recreation'),
(234, 4, 'Science and Technology'),
(235, 4, 'Scouting Skills'),
(236, 4, 'Nautical Skills'),
(237, 4, 'Advanced Nautical Skills'),
(238, 4, 'Water Activities'),
(239, 5, 'IT'),
(240, 5, 'Musician'),
(241, 5, 'Nights Away'),
(242, 5, 'Swimming'),
(243, 6, 'Nights Away'),
(244, 6, 'Camps/Sleepovers'),
(245, 6, 'Chief Scouts Bronze Award'),
(246, 6, 'Chief Scouts Silver Award'),
(247, 6, 'Chief Scouts Gold Award'),
(248, 6, 'Chief Scouts Platinum Award'),
(249, 6, 'Chief Scouts Diamond Award'),
(250, 6, 'Queen''s Scout Award'),
(251, 6, 'Other Event'),
(252, 7, 'Discovery'),
(253, 7, 'Friendship'),
(254, 7, 'Outdoor'),
(255, 8, 'Caring'),
(256, 8, 'Creative'),
(257, 8, 'Fitness'),
(258, 8, 'Global'),
(259, 8, 'Outdoors'),
(260, 9, 'Adventure'),
(261, 9, 'Community'),
(262, 9, 'Creative'),
(263, 9, 'Expenditure'),
(264, 9, 'Fitness'),
(265, 9, 'Global'),
(266, 9, 'Outdoors'),
(267, 9, 'Outdoors Plus'),
(268, 11, 'DofE Bronze Award'),
(269, 11, 'DofE Silver Award'),
(270, 11, 'DofE Gold Award'),
(271, 12, 'Participation 1'),
(272, 12, 'Participation 2'),
(273, 12, 'Participation 3'),
(274, 12, 'Participation 4'),
(275, 12, 'Participation 5'),
(276, 12, 'Participation 6'),
(277, 12, 'Participation 7'),
(278, 12, 'Participation 8'),
(279, 12, 'Participation 9');

CREATE TABLE scouting_section (
  nid int(10) unsigned NOT NULL auto_increment,
  section_type_id tinyint(2) unsigned NOT NULL default '0',
  orgstruct_id smallint(6) unsigned NOT NULL default '0',
  url varchar(100) NOT NULL default '',
  leader_id int(10) unsigned NOT NULL default '0',
  address_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY (nid)
);

CREATE TABLE scouting_section_type (
  id mediumint(9) unsigned NOT NULL auto_increment,
  name varchar(50) NOT NULL default '',
  absminage decimal(10,0) unsigned NOT NULL default '0',
  minage decimal(10,0) unsigned NOT NULL default '0',
  absmaxage decimal(10,0) unsigned NOT NULL default '0',
  maxage decimal(10,0) unsigned NOT NULL default '0',
  PRIMARY KEY (id)
);

INSERT INTO scouting_section_type (id, name, absminage, minage, absmaxage, maxage) VALUES
(1, 'Beaver Scouts', 5, 5, 8, 8),
(2, 'Cub Scouts', 8, 8, 11, 10),
(3, 'Scouts', 10, 10, 15, 14),
(4, 'Explorer Scouts', 13, 14, 18, 18),
(5, 'Scout Network', 17, 18, 25, 25);

CREATE TABLE scouting_event_category (
  id tinyint(4) unsigned NOT NULL auto_increment,
  section_type_id tinyint(2) unsigned NOT NULL default '0',
  name varchar(50) NOT NULL default '',
  PRIMARY KEY (id)
);

INSERT INTO scouting_event_category (id, section_type_id, name) VALUES
(1, 1, 'Beaver Scout Badges'),
(2, 2, 'Cub Scout Badges'),
(3, 3, 'Scout Badges'),
(4, 4, 'Explorer Scout Badges'),
(5, 0, 'Staged Badges'),
(6, 0, 'Other'),
(7, 1, 'Beaver Challenge Badges'),
(8, 2, 'Cub Challenge Badges'),
(9, 3, 'Scout Challenge Badges'),
(11, 0, 'Duke of Edinburgh''s Award'),
(12, 0, 'Participation Badge');

CREATE TABLE scouting_orgstruct (
  id smallint(6) unsigned NOT NULL auto_increment,
  parent_id smallint(6) unsigned NOT NULL default '0',
  level_id smallint(1) unsigned NOT NULL default '0',
  uid smallint(6) unsigned NOT NULL default '0',
  name varchar(50) NOT NULL default '',
  PRIMARY KEY (id)
);